function addLauncher(icontasks, applicationDesktop, applicationWmClass) {
    icontasks.currentConfigGroup = new Array("Launchers");
    var itemsLaunchers = icontasks.readConfig("Items", "");
    if (itemsLaunchers !==  "") {
        itemsLaunchers +=  ",";
    }
    itemsLaunchers +=  "file://" + applicationPath(applicationDesktop) + "?wmClass=" + applicationWmClass;
    icontasks.writeConfig("Items", itemsLaunchers);
}

function removeIcon(panel, appDesktop) {
    var iconsWidgets = panel.widgets("icon");
    var appDesktopUrl = "file://" + applicationPath(appDesktop);
    var iconUrl = "";
    for (var j in iconsWidgets) {
        iconUrl = iconsWidgets[j].readConfig("Url","noUrl");
        if (iconUrl === appDesktopUrl) {
            var myIcon = iconsWidgets[j];
            myIcon.remove();
            sleep(10);
        }
    }
}


var myActivity14 = false;
var oldPanel = false;
var userBottomPanel = false;
myActivity14 = activityById(14);
oldPanel = activityById(2);

locked = false;

if (myActivity14) {
    myActivity14.wallpaperPlugin = "image";
    myActivity14.wallpaperMode = "SingleImage";
    myActivity14.currentConfigGroup = Array('Wallpaper', 'image');
}


for (var idxPanel in panels()) {
    if ((panels()[idxPanel].id !== 2) && (panels()[idxPanel].location === "bottom")) {
        userBottomPanel = true;
        break;
    } 
}

if ((!userBottomPanel) && oldPanel) {
    loadTemplate("org.mageia.plasma-desktop.defaultPanel");

    var kickoffLauncher;
    var lancelotLauncher;
    var iconsAdded;
    var widgetsAdded;
    var newPanel = false;
    
    newPanel = panelById(Math.max.apply(null, panelIds));
    
    kickoffLauncher = oldPanel.widgets("launcher");
    if (newPanel && (kickoffLauncher.length > 0)) {
        var simpleLauncher = newPanel.widgets("simplelauncher");
        newPanel.addWidget(kickoffLauncher[0]);
        kickoffLauncher[0].index = 0;
        simpleLauncher[0].remove();
    }
    
    lancelotLauncher = oldPanel.widgets("lancelot_launcher");
    if (newPanel && (lancelotLauncher.length > 0)) {
        var simpleLauncher = newPanel.widgets("simplelauncher");
        newPanel.addWidget(lancelotLauncher[0]);
        lancelotLauncher[0].index = 0;
        simpleLauncher[0].remove();
    }
    newPanel.reloadConfig();
    
    iconsAdded = oldPanel.widgets("icon");
    if (newPanel && (iconsAdded.length > 0)) {
        var i = 3;
        for (var j in iconsAdded) {
            newPanel.addWidget(iconsAdded[j]);
            iconsAdded[j].index = i;
            i++;
        }
    }
    newPanel.reloadConfig();
    
    widgetsAdded = oldPanel.widgets();
    if (newPanel && (widgetsAdded.length > 0)) {
        for (var j in widgetsAdded) {
            newPanel.addWidget(widgetsAdded[j]);
        }
    }
    newPanel.reloadConfig();
    
    oldPanel.remove();
    
} else {

    var myPanel = false;
    myPanel = panelById(2);

    if (myPanel) {
        var showActivityManagerFound = false;
        var iconsWidgets;
        var launcherIndex = -1;
        var tasksIndex = -1;
    
        var panelWidgets = myPanel.widgets();
        for (var id in panelWidgets) {
        
          switch(panelWidgets[id].type) {
            case "simplelauncher":
                if (launcherIndex === -1) {
                    var w_simplelauncher = panelWidgets[id];
                    w_simplelauncher.writeConfig("icon", "mgabutton");
                    w_simplelauncher.writeConfig("format", "Name");
                    w_simplelauncher.writeConfig("showMenuTitles", "true");
                    w_simplelauncher.writeConfig("views", "RecentlyUsedApplications,Applications,Favorites,RecentlyUsed,RunCommand,Leave");
                    w_simplelauncher.reloadConfig();
                    launcherIndex = w_simplelauncher.index;
                }
                break;
            case "launcher":
            case "lancelot_launcher":
                if (launcherIndex === -1) {
                    launcherIndex = panelWidgets[id].index;
                }
                break;
            case "tasks":
                if (tasksIndex === -1) {
                    tasksIndex = panelWidgets[id].index;
                    panelWidgets[id].remove();
                     
                    var w_icontasks = myPanel.addWidget("icontasks");
                    w_icontasks.index = tasksIndex;
                    w_icontasks.writeConfig("showOnlyCurrentActivity","true");
                    w_icontasks.writeConfig("showOnlyCurrentDesktop","false");
                    w_icontasks.writeConfig("showOnlyCurrentScreen","false");
                    w_icontasks.writeConfig("mediaButtons","true");
                    w_icontasks.writeConfig("showProgress","true");
                    w_icontasks.writeConfig("showSeparator","0");
                    w_icontasks.writeConfig("launcherIcons","true");
                    w_icontasks.writeConfig("unity","false");
                    w_icontasks.writeConfig("style","1");
                    
                    addLauncher(w_icontasks, "dolphin.desktop", "Dolphin");
                    addLauncher(w_icontasks, "systemsettings.desktop", "Systemsettings");
                    addLauncher(w_icontasks, "mageia-drakconf.desktop", "Drakconf.real");
                    addLauncher(w_icontasks, "firefox.desktop", "Firefox");
                    
                    w_icontasks.reloadConfig();
                    
                }
                break;
            case "org.kde.showActivityManager":
                showActivityManagerFound = true;
                break;
            case "digital-clock":
                var w_clock = panelWidgets[id];
                w_clock.writeConfig("displayHolidays","false");
                w_clock.writeConfig("displayEvents","false");
                w_clock.reloadConfig();
                break;
            default:
                break;
          }

        sleep(10);
        myPanel.reloadConfig();
        }
    
        if (tasksIndex > -1) {
            removeIcon(myPanel, "dolphin.desktop");
            myPanel.reloadConfig();
            removeIcon(myPanel, "systemsettings.desktop");
            myPanel.reloadConfig();
            removeIcon(myPanel, "mageia-drakconf.desktop");
            myPanel.reloadConfig();
            removeIcon(myPanel, "firefox.desktop");
            myPanel.reloadConfig();
        }
    
        if (! showActivityManagerFound) {
            var newShowActivityManager = myPanel.addWidget("org.kde.showActivityManager");
            showActivityManagerFound = true;
            if (launcherIndex > -1) {
                newShowActivityManager.index = launcherIndex + 1;
            } else {
                newShowActivityManager.index = 0;
            }
        }
        sleep(10);
        myPanel.reloadConfig();
    }
}

sleep(10);
locked = true;

